//
//  YHMyDocumentsListViewController.swift
//  galaxy
//
//  Created by EDY on 2024/3/8.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit
/*
 *我的文书 列表
 */

class YHMyDocumentsListViewController: YHBaseViewController {
    var bottomView: UIView!
    var bottomButton: UIButton!
    var tableView: UITableView!
    var dataSource: [YHMyDocumentsListModel]?
    var viewModel: YHMyDocumentsListViewModel?
    var orderId: Int = 0
    var mobile: String = ""
    
    
    
    
    lazy var headSessionView : YHMyDocListHeaderView = {
        let view = YHMyDocListHeaderView()
        return view
    }()
    
    //头部背景图片
    lazy var headBkgImagV: UIImageView = {
        let imagV = UIImageView()
        imagV.image = UIImage(named: "my_doc_head_bkg")
        imagV.contentMode = .scaleAspectFill
        return imagV
    }()
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        viewModel = YHMyDocumentsListViewModel()
        gk_navTitle = "我的文书"
        setView()
        getData()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        getData()
    }
}

extension YHMyDocumentsListViewController {
    func getData() {
        viewModel?.requestDocumentsList("\(orderId)", mobile, callBackBlock: {[weak self] success, error in
            guard let self = self else { return }
            self.tableView.reloadData()
        })
    }
    
    func updateDataSource() {
       
        self.tableView.reloadData()
    }
    
    func setView() {
        //1
        view.addSubview(headBkgImagV)
        headBkgImagV.snp.makeConstraints { make in
            make.top.equalToSuperview()
            make.left.right.equalToSuperview()
            make.height.equalTo(312)
        }
        
        view.addSubview(headSessionView)
        headSessionView.snp.makeConstraints { make in
            make.top.equalToSuperview().offset(k_Height_NavigationtBarAndStatuBar)
            make.left.equalToSuperview().offset(kMargin)
            make.right.equalToSuperview().offset(-kMargin)
            make.height.equalTo(YHMyDocListHeaderView.viewH)
        }
        
        
        tableView = {
            let tableView = UITableView(frame:.zero, style:.plain)
            tableView.contentInsetAdjustmentBehavior = .never
            tableView.backgroundColor = .clear
            tableView.separatorStyle = .none
            tableView.delegate = self
            tableView.dataSource = self
            tableView.register(cellWithClass: YHMySignatureListTableViewCell.self)
            return tableView
        }()
        view.addSubview(tableView)
        tableView.snp.makeConstraints { make in
            make.top.equalTo(headSessionView.snp.bottom)
            make.left.right.bottom.equalToSuperview()
        }
        
//        bottomView = {
//            let bottom = UIView()
//            bottom.backgroundColor = .white
//            return bottom
//        }()
//        view.addSubview(bottomView)
//        bottomView.snp.makeConstraints { make in
//            make.left.right.bottom.equalToSuperview()
//            make.height.equalTo(k_Height_safeAreaInsetsBottom() + 64)
//        }
//
//        bottomButton = {
//            let button = UIButton(type: .custom)
//            button.titleLabel?.font = UIFont.PFSC_M(ofSize: 16)
//            button.contentHorizontalAlignment = .center
//            button.setTitle("提交", for: .normal)
//            button.setTitleColor( UIColor(hex:0xffffff), for: .normal)
//            button.layer.cornerRadius = kCornerRadius6
//            button.clipsToBounds = true
//            button.addTarget(self, action: #selector(submit), for: .touchUpInside)
//            return button
//        }()
//        bottomView.addSubview(bottomButton)
//        bottomButton.snp.makeConstraints { make in
//            make.right.equalTo(-16)
//            make.top.equalTo(8)
//            make.height.equalTo(48)
//            make.left.equalTo(16)
//        }
//
//        bottomButton.layoutIfNeeded()
//        bottomButton.addYinHeGradualLayer()
    }
    
    @objc func submit() {
        
    }
}

extension YHMyDocumentsListViewController: UITableViewDelegate, UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return viewModel?.mainModel?.docs.count ?? 0
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withClass: YHMySignatureListTableViewCell.self)
        cell.textLabel?.text = viewModel?.mainModel?.docs[indexPath.row].doc_type_name
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return CGFloat(86)
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let model = viewModel?.mainModel?.docs[indexPath.row]
        let vc = YHMyDocumentsDetailViewController()
        vc.id = model?.id ?? 0
        self.navigationController?.pushViewController(vc)
    }
}

